using UnityEngine;
using UnityEngine.InputSystem;

[RequireComponent(typeof(PlayerInput))]
public class InputActionListenerTest : MonoBehaviour
{
    private InputAction _move;
    private InputAction _jump;

    // Start is called before the first frame update
    private void Start()
    {
        var input = GetComponent<PlayerInput>();
        input.currentActionMap.Enable();
        _move = input.currentActionMap.FindAction("Move");
        _jump = input.currentActionMap.FindAction("Jump");

        // 下記のような形でリスナーを設定し、アクションの値が変化したときのみ処理を実行
        _move.performed += Move;
        _jump.performed += Jump;
    }

    private void OnDestroy()
    {
        // ゲームオブジェクトが消えるときはリスナーを解除
        _move.performed -= Move;
        _jump.performed -= Jump;
    }

    private void Move(InputAction.CallbackContext ctx)
    {
        var moveValue = _move.ReadValue<Vector2>();
        Debug.Log($"Moveアクションの値が変化したよ: {moveValue}");
    }

    private void Jump(InputAction.CallbackContext ctx)
    {
        Debug.Log("Jumpアクションが実行されたよ");
    }
}